/*
    FEARLUS model0-7: MeanSubPopParamParcelReport.h
    Copyright (C) 1999-2003  Macaulay Institute

    This file is part of FEARLUS model0-7, an agent-based model of land use
    change.

    FEARLUS model0-7 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-7 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


The interface for the MeanSubPopParamParcelReport object. This is an object
that follows the Report protocol.

The report will show the mean of all sub-population parameters over the land
parcels.

*/

#import <objectbase/SwarmObject.h>
#import "Report.h"

@class ModelSwarm, Parameter, AssocArray, Interval;

@interface MeanSubPopParamParcelReport: SwarmObject <Report> {
  Parameter *parameter;
  ModelSwarm *model;
  id <List> fixedYears;
  id <List> repeatYears;
  Interval *totNeighbourWeight, *totImitateProb,
    *totAspireThresh, *totMemorySize;
}

+(id <Report>)create: aZone;
-(void)setModelSwarm: (ModelSwarm *)m andParameters: (Parameter *)p;
-(void)reportForYear: (unsigned)year toFile: (FILE *)fp;
-(BOOL)setOption: (char *)option toValue: (char *)value;
-(BOOL)setOptionFlag: (char *)option toValue: (BOOL)value;
-(void)setFixedYears: (id <List>)y;
-(void)setRepeatYears: (id <List>)y;
-(BOOL)reportingForYear: (unsigned)year;

@end
